<?php

namespace Eater\Glim\Model\Base;

use \Exception;
use \PDO;
use Eater\Glim\Model\ServerQuery as ChildServerQuery;
use Eater\Glim\Model\Map\ServerTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\ActiveRecord\ActiveRecordInterface;
use Propel\Runtime\Collection\Collection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\BadMethodCallException;
use Propel\Runtime\Exception\LogicException;
use Propel\Runtime\Exception\PropelException;
use Propel\Runtime\Map\TableMap;
use Propel\Runtime\Parser\AbstractParser;

/**
 * Base class that represents a row from the 'Server' table.
 *
 *
 *
* @package    propel.generator..Base
*/
abstract class Server implements ActiveRecordInterface
{
    /**
     * TableMap class name
     */
    const TABLE_MAP = '\\Eater\\Glim\\Model\\Map\\ServerTableMap';


    /**
     * attribute to determine if this object has previously been saved.
     * @var boolean
     */
    protected $new = true;

    /**
     * attribute to determine whether this object has been deleted.
     * @var boolean
     */
    protected $deleted = false;

    /**
     * The columns that have been modified in current object.
     * Tracking modified columns allows us to only update modified columns.
     * @var array
     */
    protected $modifiedColumns = array();

    /**
     * The (virtual) columns that are added at runtime
     * The formatters can add supplementary columns based on a resultset
     * @var array
     */
    protected $virtualColumns = array();

    /**
     * The value for the id field.
     * @var        int
     */
    protected $id;

    /**
     * The value for the fqdn field.
     * @var        string
     */
    protected $fqdn;

    /**
     * The value for the fingerprint field.
     * @var        string
     */
    protected $fingerprint;

    /**
     * The value for the public_key field.
     * @var        string
     */
    protected $public_key;

    /**
     * The value for the certificate field.
     * @var        string
     */
    protected $certificate;

    /**
     * The value for the location field.
     * Note: this column has a database default value of: 'Unknown'
     * @var        string
     */
    protected $location;

    /**
     * The value for the speed field.
     * Note: this column has a database default value of: -1
     * @var        int
     */
    protected $speed;

    /**
     * The value for the external_ip field.
     * @var        string
     */
    protected $external_ip;

    /**
     * The value for the internal_ip field.
     * Note: this column has a database default value of: '10.24.0.0'
     * @var        string
     */
    protected $internal_ip;

    /**
     * The value for the netmask field.
     * Note: this column has a database default value of: 16
     * @var        int
     */
    protected $netmask;

    /**
     * The value for the first_dns field.
     * @var        string
     */
    protected $first_dns;

    /**
     * The value for the second_dns field.
     * @var        string
     */
    protected $second_dns;

    /**
     * The value for the port field.
     * Note: this column has a database default value of: 1194
     * @var        int
     */
    protected $port;

    /**
     * The value for the protocol field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $protocol;

    /**
     * The value for the status field.
     * Note: this column has a database default value of: 0
     * @var        int
     */
    protected $status;

    /**
     * Flag to prevent endless save loop, if this object is referenced
     * by another object which falls in this transaction.
     *
     * @var boolean
     */
    protected $alreadyInSave = false;

    /**
     * Applies default values to this object.
     * This method should be called from the object's constructor (or
     * equivalent initialization method).
     * @see __construct()
     */
    public function applyDefaultValues()
    {
        $this->location = 'Unknown';
        $this->speed = -1;
        $this->internal_ip = '10.24.0.0';
        $this->netmask = 16;
        $this->port = 1194;
        $this->protocol = 0;
        $this->status = 0;
    }

    /**
     * Initializes internal state of Eater\Glim\Model\Base\Server object.
     * @see applyDefaults()
     */
    public function __construct()
    {
        $this->applyDefaultValues();
    }

    /**
     * Returns whether the object has been modified.
     *
     * @return boolean True if the object has been modified.
     */
    public function isModified()
    {
        return !!$this->modifiedColumns;
    }

    /**
     * Has specified column been modified?
     *
     * @param  string  $col column fully qualified name (TableMap::TYPE_COLNAME), e.g. Book::AUTHOR_ID
     * @return boolean True if $col has been modified.
     */
    public function isColumnModified($col)
    {
        return $this->modifiedColumns && isset($this->modifiedColumns[$col]);
    }

    /**
     * Get the columns that have been modified in this object.
     * @return array A unique list of the modified column names for this object.
     */
    public function getModifiedColumns()
    {
        return $this->modifiedColumns ? array_keys($this->modifiedColumns) : [];
    }

    /**
     * Returns whether the object has ever been saved.  This will
     * be false, if the object was retrieved from storage or was created
     * and then saved.
     *
     * @return boolean true, if the object has never been persisted.
     */
    public function isNew()
    {
        return $this->new;
    }

    /**
     * Setter for the isNew attribute.  This method will be called
     * by Propel-generated children and objects.
     *
     * @param boolean $b the state of the object.
     */
    public function setNew($b)
    {
        $this->new = (boolean) $b;
    }

    /**
     * Whether this object has been deleted.
     * @return boolean The deleted state of this object.
     */
    public function isDeleted()
    {
        return $this->deleted;
    }

    /**
     * Specify whether this object has been deleted.
     * @param  boolean $b The deleted state of this object.
     * @return void
     */
    public function setDeleted($b)
    {
        $this->deleted = (boolean) $b;
    }

    /**
     * Sets the modified state for the object to be false.
     * @param  string $col If supplied, only the specified column is reset.
     * @return void
     */
    public function resetModified($col = null)
    {
        if (null !== $col) {
            if (isset($this->modifiedColumns[$col])) {
                unset($this->modifiedColumns[$col]);
            }
        } else {
            $this->modifiedColumns = array();
        }
    }

    /**
     * Compares this with another <code>Server</code> instance.  If
     * <code>obj</code> is an instance of <code>Server</code>, delegates to
     * <code>equals(Server)</code>.  Otherwise, returns <code>false</code>.
     *
     * @param  mixed   $obj The object to compare to.
     * @return boolean Whether equal to the object specified.
     */
    public function equals($obj)
    {
        if (!$obj instanceof static) {
            return false;
        }

        if ($this === $obj) {
            return true;
        }

        if (null === $this->getPrimaryKey() || null === $obj->getPrimaryKey()) {
            return false;
        }

        return $this->getPrimaryKey() === $obj->getPrimaryKey();
    }

    /**
     * Get the associative array of the virtual columns in this object
     *
     * @return array
     */
    public function getVirtualColumns()
    {
        return $this->virtualColumns;
    }

    /**
     * Checks the existence of a virtual column in this object
     *
     * @param  string  $name The virtual column name
     * @return boolean
     */
    public function hasVirtualColumn($name)
    {
        return array_key_exists($name, $this->virtualColumns);
    }

    /**
     * Get the value of a virtual column in this object
     *
     * @param  string $name The virtual column name
     * @return mixed
     *
     * @throws PropelException
     */
    public function getVirtualColumn($name)
    {
        if (!$this->hasVirtualColumn($name)) {
            throw new PropelException(sprintf('Cannot get value of inexistent virtual column %s.', $name));
        }

        return $this->virtualColumns[$name];
    }

    /**
     * Set the value of a virtual column in this object
     *
     * @param string $name  The virtual column name
     * @param mixed  $value The value to give to the virtual column
     *
     * @return $this|Server The current object, for fluid interface
     */
    public function setVirtualColumn($name, $value)
    {
        $this->virtualColumns[$name] = $value;

        return $this;
    }

    /**
     * Logs a message using Propel::log().
     *
     * @param  string  $msg
     * @param  int     $priority One of the Propel::LOG_* logging levels
     * @return boolean
     */
    protected function log($msg, $priority = Propel::LOG_INFO)
    {
        return Propel::log(get_class($this) . ': ' . $msg, $priority);
    }

    /**
     * Export the current object properties to a string, using a given parser format
     * <code>
     * $book = BookQuery::create()->findPk(9012);
     * echo $book->exportTo('JSON');
     *  => {"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * @param  mixed   $parser                 A AbstractParser instance, or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param  boolean $includeLazyLoadColumns (optional) Whether to include lazy load(ed) columns. Defaults to TRUE.
     * @return string  The exported data
     */
    public function exportTo($parser, $includeLazyLoadColumns = true)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        return $parser->fromArray($this->toArray(TableMap::TYPE_PHPNAME, $includeLazyLoadColumns, array(), true));
    }

    /**
     * Clean up internal collections prior to serializing
     * Avoids recursive loops that turn into segmentation faults when serializing
     */
    public function __sleep()
    {
        $this->clearAllReferences();

        return array_keys(get_object_vars($this));
    }

    /**
     * Get the [id] column value.
     *
     * @return int
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * Get the [fqdn] column value.
     *
     * @return string
     */
    public function getFqdn()
    {
        return $this->fqdn;
    }

    /**
     * Get the [fingerprint] column value.
     *
     * @return string
     */
    public function getFingerprint()
    {
        return $this->fingerprint;
    }

    /**
     * Get the [public_key] column value.
     *
     * @return string
     */
    public function getPublicKey()
    {
        return $this->public_key;
    }

    /**
     * Get the [certificate] column value.
     *
     * @return string
     */
    public function getCertificate()
    {
        return $this->certificate;
    }

    /**
     * Get the [location] column value.
     *
     * @return string
     */
    public function getLocation()
    {
        return $this->location;
    }

    /**
     * Get the [speed] column value.
     *
     * @return int
     */
    public function getSpeed()
    {
        return $this->speed;
    }

    /**
     * Get the [external_ip] column value.
     *
     * @return string
     */
    public function getExternalIp()
    {
        return $this->external_ip;
    }

    /**
     * Get the [internal_ip] column value.
     *
     * @return string
     */
    public function getInternalIp()
    {
        return $this->internal_ip;
    }

    /**
     * Get the [netmask] column value.
     *
     * @return int
     */
    public function getNetmask()
    {
        return $this->netmask;
    }

    /**
     * Get the [first_dns] column value.
     *
     * @return string
     */
    public function getFirstDns()
    {
        return $this->first_dns;
    }

    /**
     * Get the [second_dns] column value.
     *
     * @return string
     */
    public function getSecondDns()
    {
        return $this->second_dns;
    }

    /**
     * Get the [port] column value.
     *
     * @return int
     */
    public function getPort()
    {
        return $this->port;
    }

    /**
     * Get the [protocol] column value.
     *
     * @return string
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getProtocol()
    {
        if (null === $this->protocol) {
            return null;
        }
        $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_PROTOCOL);
        if (!isset($valueSet[$this->protocol])) {
            throw new PropelException('Unknown stored enum key: ' . $this->protocol);
        }

        return $valueSet[$this->protocol];
    }

    /**
     * Get the [status] column value.
     *
     * @return string
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function getStatus()
    {
        if (null === $this->status) {
            return null;
        }
        $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_STATUS);
        if (!isset($valueSet[$this->status])) {
            throw new PropelException('Unknown stored enum key: ' . $this->status);
        }

        return $valueSet[$this->status];
    }

    /**
     * Set the value of [id] column.
     *
     * @param int $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setId($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->id !== $v) {
            $this->id = $v;
            $this->modifiedColumns[ServerTableMap::COL_ID] = true;
        }

        return $this;
    } // setId()

    /**
     * Set the value of [fqdn] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setFqdn($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->fqdn !== $v) {
            $this->fqdn = $v;
            $this->modifiedColumns[ServerTableMap::COL_FQDN] = true;
        }

        return $this;
    } // setFqdn()

    /**
     * Set the value of [fingerprint] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setFingerprint($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->fingerprint !== $v) {
            $this->fingerprint = $v;
            $this->modifiedColumns[ServerTableMap::COL_FINGERPRINT] = true;
        }

        return $this;
    } // setFingerprint()

    /**
     * Set the value of [public_key] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setPublicKey($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->public_key !== $v) {
            $this->public_key = $v;
            $this->modifiedColumns[ServerTableMap::COL_PUBLIC_KEY] = true;
        }

        return $this;
    } // setPublicKey()

    /**
     * Set the value of [certificate] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setCertificate($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->certificate !== $v) {
            $this->certificate = $v;
            $this->modifiedColumns[ServerTableMap::COL_CERTIFICATE] = true;
        }

        return $this;
    } // setCertificate()

    /**
     * Set the value of [location] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setLocation($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->location !== $v) {
            $this->location = $v;
            $this->modifiedColumns[ServerTableMap::COL_LOCATION] = true;
        }

        return $this;
    } // setLocation()

    /**
     * Set the value of [speed] column.
     *
     * @param int $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setSpeed($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->speed !== $v) {
            $this->speed = $v;
            $this->modifiedColumns[ServerTableMap::COL_SPEED] = true;
        }

        return $this;
    } // setSpeed()

    /**
     * Set the value of [external_ip] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setExternalIp($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->external_ip !== $v) {
            $this->external_ip = $v;
            $this->modifiedColumns[ServerTableMap::COL_EXTERNAL_IP] = true;
        }

        return $this;
    } // setExternalIp()

    /**
     * Set the value of [internal_ip] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setInternalIp($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->internal_ip !== $v) {
            $this->internal_ip = $v;
            $this->modifiedColumns[ServerTableMap::COL_INTERNAL_IP] = true;
        }

        return $this;
    } // setInternalIp()

    /**
     * Set the value of [netmask] column.
     *
     * @param int $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setNetmask($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->netmask !== $v) {
            $this->netmask = $v;
            $this->modifiedColumns[ServerTableMap::COL_NETMASK] = true;
        }

        return $this;
    } // setNetmask()

    /**
     * Set the value of [first_dns] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setFirstDns($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->first_dns !== $v) {
            $this->first_dns = $v;
            $this->modifiedColumns[ServerTableMap::COL_FIRST_DNS] = true;
        }

        return $this;
    } // setFirstDns()

    /**
     * Set the value of [second_dns] column.
     *
     * @param string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setSecondDns($v)
    {
        if ($v !== null) {
            $v = (string) $v;
        }

        if ($this->second_dns !== $v) {
            $this->second_dns = $v;
            $this->modifiedColumns[ServerTableMap::COL_SECOND_DNS] = true;
        }

        return $this;
    } // setSecondDns()

    /**
     * Set the value of [port] column.
     *
     * @param int $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     */
    public function setPort($v)
    {
        if ($v !== null) {
            $v = (int) $v;
        }

        if ($this->port !== $v) {
            $this->port = $v;
            $this->modifiedColumns[ServerTableMap::COL_PORT] = true;
        }

        return $this;
    } // setPort()

    /**
     * Set the value of [protocol] column.
     *
     * @param  string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function setProtocol($v)
    {
        if ($v !== null) {
            $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_PROTOCOL);
            if (!in_array($v, $valueSet)) {
                throw new PropelException(sprintf('Value "%s" is not accepted in this enumerated column', $v));
            }
            $v = array_search($v, $valueSet);
        }

        if ($this->protocol !== $v) {
            $this->protocol = $v;
            $this->modifiedColumns[ServerTableMap::COL_PROTOCOL] = true;
        }

        return $this;
    } // setProtocol()

    /**
     * Set the value of [status] column.
     *
     * @param  string $v new value
     * @return $this|\Eater\Glim\Model\Server The current object (for fluent API support)
     * @throws \Propel\Runtime\Exception\PropelException
     */
    public function setStatus($v)
    {
        if ($v !== null) {
            $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_STATUS);
            if (!in_array($v, $valueSet)) {
                throw new PropelException(sprintf('Value "%s" is not accepted in this enumerated column', $v));
            }
            $v = array_search($v, $valueSet);
        }

        if ($this->status !== $v) {
            $this->status = $v;
            $this->modifiedColumns[ServerTableMap::COL_STATUS] = true;
        }

        return $this;
    } // setStatus()

    /**
     * Indicates whether the columns in this object are only set to default values.
     *
     * This method can be used in conjunction with isModified() to indicate whether an object is both
     * modified _and_ has some values set which are non-default.
     *
     * @return boolean Whether the columns in this object are only been set with default values.
     */
    public function hasOnlyDefaultValues()
    {
            if ($this->location !== 'Unknown') {
                return false;
            }

            if ($this->speed !== -1) {
                return false;
            }

            if ($this->internal_ip !== '10.24.0.0') {
                return false;
            }

            if ($this->netmask !== 16) {
                return false;
            }

            if ($this->port !== 1194) {
                return false;
            }

            if ($this->protocol !== 0) {
                return false;
            }

            if ($this->status !== 0) {
                return false;
            }

        // otherwise, everything was equal, so return TRUE
        return true;
    } // hasOnlyDefaultValues()

    /**
     * Hydrates (populates) the object variables with values from the database resultset.
     *
     * An offset (0-based "start column") is specified so that objects can be hydrated
     * with a subset of the columns in the resultset rows.  This is needed, for example,
     * for results of JOIN queries where the resultset row includes columns from two or
     * more tables.
     *
     * @param array   $row       The row returned by DataFetcher->fetch().
     * @param int     $startcol  0-based offset column which indicates which restultset column to start with.
     * @param boolean $rehydrate Whether this object is being re-hydrated from the database.
     * @param string  $indexType The index type of $row. Mostly DataFetcher->getIndexType().
                                  One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                            TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *
     * @return int             next starting column
     * @throws PropelException - Any caught Exception will be rewrapped as a PropelException.
     */
    public function hydrate($row, $startcol = 0, $rehydrate = false, $indexType = TableMap::TYPE_NUM)
    {
        try {

            $col = $row[TableMap::TYPE_NUM == $indexType ? 0 + $startcol : ServerTableMap::translateFieldName('Id', TableMap::TYPE_PHPNAME, $indexType)];
            $this->id = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 1 + $startcol : ServerTableMap::translateFieldName('Fqdn', TableMap::TYPE_PHPNAME, $indexType)];
            $this->fqdn = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 2 + $startcol : ServerTableMap::translateFieldName('Fingerprint', TableMap::TYPE_PHPNAME, $indexType)];
            $this->fingerprint = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 3 + $startcol : ServerTableMap::translateFieldName('PublicKey', TableMap::TYPE_PHPNAME, $indexType)];
            $this->public_key = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 4 + $startcol : ServerTableMap::translateFieldName('Certificate', TableMap::TYPE_PHPNAME, $indexType)];
            $this->certificate = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 5 + $startcol : ServerTableMap::translateFieldName('Location', TableMap::TYPE_PHPNAME, $indexType)];
            $this->location = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 6 + $startcol : ServerTableMap::translateFieldName('Speed', TableMap::TYPE_PHPNAME, $indexType)];
            $this->speed = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 7 + $startcol : ServerTableMap::translateFieldName('ExternalIp', TableMap::TYPE_PHPNAME, $indexType)];
            $this->external_ip = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 8 + $startcol : ServerTableMap::translateFieldName('InternalIp', TableMap::TYPE_PHPNAME, $indexType)];
            $this->internal_ip = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 9 + $startcol : ServerTableMap::translateFieldName('Netmask', TableMap::TYPE_PHPNAME, $indexType)];
            $this->netmask = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 10 + $startcol : ServerTableMap::translateFieldName('FirstDns', TableMap::TYPE_PHPNAME, $indexType)];
            $this->first_dns = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 11 + $startcol : ServerTableMap::translateFieldName('SecondDns', TableMap::TYPE_PHPNAME, $indexType)];
            $this->second_dns = (null !== $col) ? (string) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 12 + $startcol : ServerTableMap::translateFieldName('Port', TableMap::TYPE_PHPNAME, $indexType)];
            $this->port = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 13 + $startcol : ServerTableMap::translateFieldName('Protocol', TableMap::TYPE_PHPNAME, $indexType)];
            $this->protocol = (null !== $col) ? (int) $col : null;

            $col = $row[TableMap::TYPE_NUM == $indexType ? 14 + $startcol : ServerTableMap::translateFieldName('Status', TableMap::TYPE_PHPNAME, $indexType)];
            $this->status = (null !== $col) ? (int) $col : null;
            $this->resetModified();

            $this->setNew(false);

            if ($rehydrate) {
                $this->ensureConsistency();
            }

            return $startcol + 15; // 15 = ServerTableMap::NUM_HYDRATE_COLUMNS.

        } catch (Exception $e) {
            throw new PropelException(sprintf('Error populating %s object', '\\Eater\\Glim\\Model\\Server'), 0, $e);
        }
    }

    /**
     * Checks and repairs the internal consistency of the object.
     *
     * This method is executed after an already-instantiated object is re-hydrated
     * from the database.  It exists to check any foreign keys to make sure that
     * the objects related to the current object are correct based on foreign key.
     *
     * You can override this method in the stub class, but you should always invoke
     * the base method from the overridden method (i.e. parent::ensureConsistency()),
     * in case your model changes.
     *
     * @throws PropelException
     */
    public function ensureConsistency()
    {
    } // ensureConsistency

    /**
     * Reloads this object from datastore based on primary key and (optionally) resets all associated objects.
     *
     * This will only work if the object has been saved and has a valid primary key set.
     *
     * @param      boolean $deep (optional) Whether to also de-associated any related objects.
     * @param      ConnectionInterface $con (optional) The ConnectionInterface connection to use.
     * @return void
     * @throws PropelException - if this object is deleted, unsaved or doesn't have pk match in db
     */
    public function reload($deep = false, ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("Cannot reload a deleted object.");
        }

        if ($this->isNew()) {
            throw new PropelException("Cannot reload an unsaved object.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(ServerTableMap::DATABASE_NAME);
        }

        // We don't need to alter the object instance pool; we're just modifying this instance
        // already in the pool.

        $dataFetcher = ChildServerQuery::create(null, $this->buildPkeyCriteria())->setFormatter(ModelCriteria::FORMAT_STATEMENT)->find($con);
        $row = $dataFetcher->fetch();
        $dataFetcher->close();
        if (!$row) {
            throw new PropelException('Cannot find matching row in the database to reload object values.');
        }
        $this->hydrate($row, 0, true, $dataFetcher->getIndexType()); // rehydrate

        if ($deep) {  // also de-associate any related objects?

        } // if (deep)
    }

    /**
     * Removes this object from datastore and sets delete attribute.
     *
     * @param      ConnectionInterface $con
     * @return void
     * @throws PropelException
     * @see Server::setDeleted()
     * @see Server::isDeleted()
     */
    public function delete(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("This object has already been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(ServerTableMap::DATABASE_NAME);
        }

        $con->transaction(function () use ($con) {
            $deleteQuery = ChildServerQuery::create()
                ->filterByPrimaryKey($this->getPrimaryKey());
            $ret = $this->preDelete($con);
            if ($ret) {
                $deleteQuery->delete($con);
                $this->postDelete($con);
                $this->setDeleted(true);
            }
        });
    }

    /**
     * Persists this object to the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All modified related objects will also be persisted in the doSave()
     * method.  This method wraps all precipitate database operations in a
     * single transaction.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see doSave()
     */
    public function save(ConnectionInterface $con = null)
    {
        if ($this->isDeleted()) {
            throw new PropelException("You cannot save an object that has been deleted.");
        }

        if ($con === null) {
            $con = Propel::getServiceContainer()->getWriteConnection(ServerTableMap::DATABASE_NAME);
        }

        return $con->transaction(function () use ($con) {
            $isInsert = $this->isNew();
            $ret = $this->preSave($con);
            if ($isInsert) {
                $ret = $ret && $this->preInsert($con);
            } else {
                $ret = $ret && $this->preUpdate($con);
            }
            if ($ret) {
                $affectedRows = $this->doSave($con);
                if ($isInsert) {
                    $this->postInsert($con);
                } else {
                    $this->postUpdate($con);
                }
                $this->postSave($con);
                ServerTableMap::addInstanceToPool($this);
            } else {
                $affectedRows = 0;
            }

            return $affectedRows;
        });
    }

    /**
     * Performs the work of inserting or updating the row in the database.
     *
     * If the object is new, it inserts it; otherwise an update is performed.
     * All related objects are also updated in this method.
     *
     * @param      ConnectionInterface $con
     * @return int             The number of rows affected by this insert/update and any referring fk objects' save() operations.
     * @throws PropelException
     * @see save()
     */
    protected function doSave(ConnectionInterface $con)
    {
        $affectedRows = 0; // initialize var to track total num of affected rows
        if (!$this->alreadyInSave) {
            $this->alreadyInSave = true;

            if ($this->isNew() || $this->isModified()) {
                // persist changes
                if ($this->isNew()) {
                    $this->doInsert($con);
                    $affectedRows += 1;
                } else {
                    $affectedRows += $this->doUpdate($con);
                }
                $this->resetModified();
            }

            $this->alreadyInSave = false;

        }

        return $affectedRows;
    } // doSave()

    /**
     * Insert the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @throws PropelException
     * @see doSave()
     */
    protected function doInsert(ConnectionInterface $con)
    {
        $modifiedColumns = array();
        $index = 0;

        $this->modifiedColumns[ServerTableMap::COL_ID] = true;
        if (null !== $this->id) {
            throw new PropelException('Cannot insert a value for auto-increment primary key (' . ServerTableMap::COL_ID . ')');
        }

         // check the columns in natural order for more readable SQL queries
        if ($this->isColumnModified(ServerTableMap::COL_ID)) {
            $modifiedColumns[':p' . $index++]  = 'id';
        }
        if ($this->isColumnModified(ServerTableMap::COL_FQDN)) {
            $modifiedColumns[':p' . $index++]  = 'fqdn';
        }
        if ($this->isColumnModified(ServerTableMap::COL_FINGERPRINT)) {
            $modifiedColumns[':p' . $index++]  = 'fingerprint';
        }
        if ($this->isColumnModified(ServerTableMap::COL_PUBLIC_KEY)) {
            $modifiedColumns[':p' . $index++]  = 'public_key';
        }
        if ($this->isColumnModified(ServerTableMap::COL_CERTIFICATE)) {
            $modifiedColumns[':p' . $index++]  = 'certificate';
        }
        if ($this->isColumnModified(ServerTableMap::COL_LOCATION)) {
            $modifiedColumns[':p' . $index++]  = 'location';
        }
        if ($this->isColumnModified(ServerTableMap::COL_SPEED)) {
            $modifiedColumns[':p' . $index++]  = 'speed';
        }
        if ($this->isColumnModified(ServerTableMap::COL_EXTERNAL_IP)) {
            $modifiedColumns[':p' . $index++]  = 'external_ip';
        }
        if ($this->isColumnModified(ServerTableMap::COL_INTERNAL_IP)) {
            $modifiedColumns[':p' . $index++]  = 'internal_ip';
        }
        if ($this->isColumnModified(ServerTableMap::COL_NETMASK)) {
            $modifiedColumns[':p' . $index++]  = 'netmask';
        }
        if ($this->isColumnModified(ServerTableMap::COL_FIRST_DNS)) {
            $modifiedColumns[':p' . $index++]  = 'first_dns';
        }
        if ($this->isColumnModified(ServerTableMap::COL_SECOND_DNS)) {
            $modifiedColumns[':p' . $index++]  = 'second_dns';
        }
        if ($this->isColumnModified(ServerTableMap::COL_PORT)) {
            $modifiedColumns[':p' . $index++]  = 'port';
        }
        if ($this->isColumnModified(ServerTableMap::COL_PROTOCOL)) {
            $modifiedColumns[':p' . $index++]  = 'protocol';
        }
        if ($this->isColumnModified(ServerTableMap::COL_STATUS)) {
            $modifiedColumns[':p' . $index++]  = 'status';
        }

        $sql = sprintf(
            'INSERT INTO Server (%s) VALUES (%s)',
            implode(', ', $modifiedColumns),
            implode(', ', array_keys($modifiedColumns))
        );

        try {
            $stmt = $con->prepare($sql);
            foreach ($modifiedColumns as $identifier => $columnName) {
                switch ($columnName) {
                    case 'id':
                        $stmt->bindValue($identifier, $this->id, PDO::PARAM_INT);
                        break;
                    case 'fqdn':
                        $stmt->bindValue($identifier, $this->fqdn, PDO::PARAM_STR);
                        break;
                    case 'fingerprint':
                        $stmt->bindValue($identifier, $this->fingerprint, PDO::PARAM_STR);
                        break;
                    case 'public_key':
                        $stmt->bindValue($identifier, $this->public_key, PDO::PARAM_STR);
                        break;
                    case 'certificate':
                        $stmt->bindValue($identifier, $this->certificate, PDO::PARAM_STR);
                        break;
                    case 'location':
                        $stmt->bindValue($identifier, $this->location, PDO::PARAM_STR);
                        break;
                    case 'speed':
                        $stmt->bindValue($identifier, $this->speed, PDO::PARAM_INT);
                        break;
                    case 'external_ip':
                        $stmt->bindValue($identifier, $this->external_ip, PDO::PARAM_STR);
                        break;
                    case 'internal_ip':
                        $stmt->bindValue($identifier, $this->internal_ip, PDO::PARAM_STR);
                        break;
                    case 'netmask':
                        $stmt->bindValue($identifier, $this->netmask, PDO::PARAM_INT);
                        break;
                    case 'first_dns':
                        $stmt->bindValue($identifier, $this->first_dns, PDO::PARAM_STR);
                        break;
                    case 'second_dns':
                        $stmt->bindValue($identifier, $this->second_dns, PDO::PARAM_STR);
                        break;
                    case 'port':
                        $stmt->bindValue($identifier, $this->port, PDO::PARAM_INT);
                        break;
                    case 'protocol':
                        $stmt->bindValue($identifier, $this->protocol, PDO::PARAM_INT);
                        break;
                    case 'status':
                        $stmt->bindValue($identifier, $this->status, PDO::PARAM_INT);
                        break;
                }
            }
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute INSERT statement [%s]', $sql), 0, $e);
        }

        try {
            $pk = $con->lastInsertId();
        } catch (Exception $e) {
            throw new PropelException('Unable to get autoincrement id.', 0, $e);
        }
        $this->setId($pk);

        $this->setNew(false);
    }

    /**
     * Update the row in the database.
     *
     * @param      ConnectionInterface $con
     *
     * @return Integer Number of updated rows
     * @see doSave()
     */
    protected function doUpdate(ConnectionInterface $con)
    {
        $selectCriteria = $this->buildPkeyCriteria();
        $valuesCriteria = $this->buildCriteria();

        return $selectCriteria->doUpdate($valuesCriteria, $con);
    }

    /**
     * Retrieves a field from the object by name passed in as a string.
     *
     * @param      string $name name
     * @param      string $type The type of fieldname the $name is of:
     *                     one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                     TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                     Defaults to TableMap::TYPE_PHPNAME.
     * @return mixed Value of field.
     */
    public function getByName($name, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = ServerTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);
        $field = $this->getByPosition($pos);

        return $field;
    }

    /**
     * Retrieves a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param      int $pos position in xml schema
     * @return mixed Value of field at $pos
     */
    public function getByPosition($pos)
    {
        switch ($pos) {
            case 0:
                return $this->getId();
                break;
            case 1:
                return $this->getFqdn();
                break;
            case 2:
                return $this->getFingerprint();
                break;
            case 3:
                return $this->getPublicKey();
                break;
            case 4:
                return $this->getCertificate();
                break;
            case 5:
                return $this->getLocation();
                break;
            case 6:
                return $this->getSpeed();
                break;
            case 7:
                return $this->getExternalIp();
                break;
            case 8:
                return $this->getInternalIp();
                break;
            case 9:
                return $this->getNetmask();
                break;
            case 10:
                return $this->getFirstDns();
                break;
            case 11:
                return $this->getSecondDns();
                break;
            case 12:
                return $this->getPort();
                break;
            case 13:
                return $this->getProtocol();
                break;
            case 14:
                return $this->getStatus();
                break;
            default:
                return null;
                break;
        } // switch()
    }

    /**
     * Exports the object as an array.
     *
     * You can specify the key type of the array by passing one of the class
     * type constants.
     *
     * @param     string  $keyType (optional) One of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     *                    TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                    Defaults to TableMap::TYPE_PHPNAME.
     * @param     boolean $includeLazyLoadColumns (optional) Whether to include lazy loaded columns. Defaults to TRUE.
     * @param     array $alreadyDumpedObjects List of objects to skip to avoid recursion
     *
     * @return array an associative array containing the field names (as keys) and field values
     */
    public function toArray($keyType = TableMap::TYPE_PHPNAME, $includeLazyLoadColumns = true, $alreadyDumpedObjects = array())
    {

        if (isset($alreadyDumpedObjects['Server'][$this->hashCode()])) {
            return '*RECURSION*';
        }
        $alreadyDumpedObjects['Server'][$this->hashCode()] = true;
        $keys = ServerTableMap::getFieldNames($keyType);
        $result = array(
            $keys[0] => $this->getId(),
            $keys[1] => $this->getFqdn(),
            $keys[2] => $this->getFingerprint(),
            $keys[3] => $this->getPublicKey(),
            $keys[4] => $this->getCertificate(),
            $keys[5] => $this->getLocation(),
            $keys[6] => $this->getSpeed(),
            $keys[7] => $this->getExternalIp(),
            $keys[8] => $this->getInternalIp(),
            $keys[9] => $this->getNetmask(),
            $keys[10] => $this->getFirstDns(),
            $keys[11] => $this->getSecondDns(),
            $keys[12] => $this->getPort(),
            $keys[13] => $this->getProtocol(),
            $keys[14] => $this->getStatus(),
        );
        $virtualColumns = $this->virtualColumns;
        foreach ($virtualColumns as $key => $virtualColumn) {
            $result[$key] = $virtualColumn;
        }


        return $result;
    }

    /**
     * Sets a field from the object by name passed in as a string.
     *
     * @param  string $name
     * @param  mixed  $value field value
     * @param  string $type The type of fieldname the $name is of:
     *                one of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME
     *                TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     *                Defaults to TableMap::TYPE_PHPNAME.
     * @return $this|\Eater\Glim\Model\Server
     */
    public function setByName($name, $value, $type = TableMap::TYPE_PHPNAME)
    {
        $pos = ServerTableMap::translateFieldName($name, $type, TableMap::TYPE_NUM);

        return $this->setByPosition($pos, $value);
    }

    /**
     * Sets a field from the object by Position as specified in the xml schema.
     * Zero-based.
     *
     * @param  int $pos position in xml schema
     * @param  mixed $value field value
     * @return $this|\Eater\Glim\Model\Server
     */
    public function setByPosition($pos, $value)
    {
        switch ($pos) {
            case 0:
                $this->setId($value);
                break;
            case 1:
                $this->setFqdn($value);
                break;
            case 2:
                $this->setFingerprint($value);
                break;
            case 3:
                $this->setPublicKey($value);
                break;
            case 4:
                $this->setCertificate($value);
                break;
            case 5:
                $this->setLocation($value);
                break;
            case 6:
                $this->setSpeed($value);
                break;
            case 7:
                $this->setExternalIp($value);
                break;
            case 8:
                $this->setInternalIp($value);
                break;
            case 9:
                $this->setNetmask($value);
                break;
            case 10:
                $this->setFirstDns($value);
                break;
            case 11:
                $this->setSecondDns($value);
                break;
            case 12:
                $this->setPort($value);
                break;
            case 13:
                $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_PROTOCOL);
                if (isset($valueSet[$value])) {
                    $value = $valueSet[$value];
                }
                $this->setProtocol($value);
                break;
            case 14:
                $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_STATUS);
                if (isset($valueSet[$value])) {
                    $value = $valueSet[$value];
                }
                $this->setStatus($value);
                break;
        } // switch()

        return $this;
    }

    /**
     * Populates the object using an array.
     *
     * This is particularly useful when populating an object from one of the
     * request arrays (e.g. $_POST).  This method goes through the column
     * names, checking to see whether a matching key exists in populated
     * array. If so the setByName() method is called for that column.
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param      array  $arr     An array to populate the object from.
     * @param      string $keyType The type of keys the array uses.
     * @return void
     */
    public function fromArray($arr, $keyType = TableMap::TYPE_PHPNAME)
    {
        $keys = ServerTableMap::getFieldNames($keyType);

        if (array_key_exists($keys[0], $arr)) {
            $this->setId($arr[$keys[0]]);
        }
        if (array_key_exists($keys[1], $arr)) {
            $this->setFqdn($arr[$keys[1]]);
        }
        if (array_key_exists($keys[2], $arr)) {
            $this->setFingerprint($arr[$keys[2]]);
        }
        if (array_key_exists($keys[3], $arr)) {
            $this->setPublicKey($arr[$keys[3]]);
        }
        if (array_key_exists($keys[4], $arr)) {
            $this->setCertificate($arr[$keys[4]]);
        }
        if (array_key_exists($keys[5], $arr)) {
            $this->setLocation($arr[$keys[5]]);
        }
        if (array_key_exists($keys[6], $arr)) {
            $this->setSpeed($arr[$keys[6]]);
        }
        if (array_key_exists($keys[7], $arr)) {
            $this->setExternalIp($arr[$keys[7]]);
        }
        if (array_key_exists($keys[8], $arr)) {
            $this->setInternalIp($arr[$keys[8]]);
        }
        if (array_key_exists($keys[9], $arr)) {
            $this->setNetmask($arr[$keys[9]]);
        }
        if (array_key_exists($keys[10], $arr)) {
            $this->setFirstDns($arr[$keys[10]]);
        }
        if (array_key_exists($keys[11], $arr)) {
            $this->setSecondDns($arr[$keys[11]]);
        }
        if (array_key_exists($keys[12], $arr)) {
            $this->setPort($arr[$keys[12]]);
        }
        if (array_key_exists($keys[13], $arr)) {
            $this->setProtocol($arr[$keys[13]]);
        }
        if (array_key_exists($keys[14], $arr)) {
            $this->setStatus($arr[$keys[14]]);
        }
    }

     /**
     * Populate the current object from a string, using a given parser format
     * <code>
     * $book = new Book();
     * $book->importFrom('JSON', '{"Id":9012,"Title":"Don Juan","ISBN":"0140422161","Price":12.99,"PublisherId":1234,"AuthorId":5678}');
     * </code>
     *
     * You can specify the key type of the array by additionally passing one
     * of the class type constants TableMap::TYPE_PHPNAME, TableMap::TYPE_CAMELNAME,
     * TableMap::TYPE_COLNAME, TableMap::TYPE_FIELDNAME, TableMap::TYPE_NUM.
     * The default key type is the column's TableMap::TYPE_PHPNAME.
     *
     * @param mixed $parser A AbstractParser instance,
     *                       or a format name ('XML', 'YAML', 'JSON', 'CSV')
     * @param string $data The source data to import from
     * @param string $keyType The type of keys the array uses.
     *
     * @return $this|\Eater\Glim\Model\Server The current object, for fluid interface
     */
    public function importFrom($parser, $data, $keyType = TableMap::TYPE_PHPNAME)
    {
        if (!$parser instanceof AbstractParser) {
            $parser = AbstractParser::getParser($parser);
        }

        $this->fromArray($parser->toArray($data), $keyType);

        return $this;
    }

    /**
     * Build a Criteria object containing the values of all modified columns in this object.
     *
     * @return Criteria The Criteria object containing all modified values.
     */
    public function buildCriteria()
    {
        $criteria = new Criteria(ServerTableMap::DATABASE_NAME);

        if ($this->isColumnModified(ServerTableMap::COL_ID)) {
            $criteria->add(ServerTableMap::COL_ID, $this->id);
        }
        if ($this->isColumnModified(ServerTableMap::COL_FQDN)) {
            $criteria->add(ServerTableMap::COL_FQDN, $this->fqdn);
        }
        if ($this->isColumnModified(ServerTableMap::COL_FINGERPRINT)) {
            $criteria->add(ServerTableMap::COL_FINGERPRINT, $this->fingerprint);
        }
        if ($this->isColumnModified(ServerTableMap::COL_PUBLIC_KEY)) {
            $criteria->add(ServerTableMap::COL_PUBLIC_KEY, $this->public_key);
        }
        if ($this->isColumnModified(ServerTableMap::COL_CERTIFICATE)) {
            $criteria->add(ServerTableMap::COL_CERTIFICATE, $this->certificate);
        }
        if ($this->isColumnModified(ServerTableMap::COL_LOCATION)) {
            $criteria->add(ServerTableMap::COL_LOCATION, $this->location);
        }
        if ($this->isColumnModified(ServerTableMap::COL_SPEED)) {
            $criteria->add(ServerTableMap::COL_SPEED, $this->speed);
        }
        if ($this->isColumnModified(ServerTableMap::COL_EXTERNAL_IP)) {
            $criteria->add(ServerTableMap::COL_EXTERNAL_IP, $this->external_ip);
        }
        if ($this->isColumnModified(ServerTableMap::COL_INTERNAL_IP)) {
            $criteria->add(ServerTableMap::COL_INTERNAL_IP, $this->internal_ip);
        }
        if ($this->isColumnModified(ServerTableMap::COL_NETMASK)) {
            $criteria->add(ServerTableMap::COL_NETMASK, $this->netmask);
        }
        if ($this->isColumnModified(ServerTableMap::COL_FIRST_DNS)) {
            $criteria->add(ServerTableMap::COL_FIRST_DNS, $this->first_dns);
        }
        if ($this->isColumnModified(ServerTableMap::COL_SECOND_DNS)) {
            $criteria->add(ServerTableMap::COL_SECOND_DNS, $this->second_dns);
        }
        if ($this->isColumnModified(ServerTableMap::COL_PORT)) {
            $criteria->add(ServerTableMap::COL_PORT, $this->port);
        }
        if ($this->isColumnModified(ServerTableMap::COL_PROTOCOL)) {
            $criteria->add(ServerTableMap::COL_PROTOCOL, $this->protocol);
        }
        if ($this->isColumnModified(ServerTableMap::COL_STATUS)) {
            $criteria->add(ServerTableMap::COL_STATUS, $this->status);
        }

        return $criteria;
    }

    /**
     * Builds a Criteria object containing the primary key for this object.
     *
     * Unlike buildCriteria() this method includes the primary key values regardless
     * of whether or not they have been modified.
     *
     * @throws LogicException if no primary key is defined
     *
     * @return Criteria The Criteria object containing value(s) for primary key(s).
     */
    public function buildPkeyCriteria()
    {
        $criteria = ChildServerQuery::create();
        $criteria->add(ServerTableMap::COL_ID, $this->id);

        return $criteria;
    }

    /**
     * If the primary key is not null, return the hashcode of the
     * primary key. Otherwise, return the hash code of the object.
     *
     * @return int Hashcode
     */
    public function hashCode()
    {
        $validPk = null !== $this->getId();

        $validPrimaryKeyFKs = 0;
        $primaryKeyFKs = [];

        if ($validPk) {
            return crc32(json_encode($this->getPrimaryKey(), JSON_UNESCAPED_UNICODE));
        } elseif ($validPrimaryKeyFKs) {
            return crc32(json_encode($primaryKeyFKs, JSON_UNESCAPED_UNICODE));
        }

        return spl_object_hash($this);
    }

    /**
     * Returns the primary key for this object (row).
     * @return int
     */
    public function getPrimaryKey()
    {
        return $this->getId();
    }

    /**
     * Generic method to set the primary key (id column).
     *
     * @param       int $key Primary key.
     * @return void
     */
    public function setPrimaryKey($key)
    {
        $this->setId($key);
    }

    /**
     * Returns true if the primary key for this object is null.
     * @return boolean
     */
    public function isPrimaryKeyNull()
    {
        return null === $this->getId();
    }

    /**
     * Sets contents of passed object to values from current object.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param      object $copyObj An object of \Eater\Glim\Model\Server (or compatible) type.
     * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @param      boolean $makeNew Whether to reset autoincrement PKs and make the object new.
     * @throws PropelException
     */
    public function copyInto($copyObj, $deepCopy = false, $makeNew = true)
    {
        $copyObj->setFqdn($this->getFqdn());
        $copyObj->setFingerprint($this->getFingerprint());
        $copyObj->setPublicKey($this->getPublicKey());
        $copyObj->setCertificate($this->getCertificate());
        $copyObj->setLocation($this->getLocation());
        $copyObj->setSpeed($this->getSpeed());
        $copyObj->setExternalIp($this->getExternalIp());
        $copyObj->setInternalIp($this->getInternalIp());
        $copyObj->setNetmask($this->getNetmask());
        $copyObj->setFirstDns($this->getFirstDns());
        $copyObj->setSecondDns($this->getSecondDns());
        $copyObj->setPort($this->getPort());
        $copyObj->setProtocol($this->getProtocol());
        $copyObj->setStatus($this->getStatus());
        if ($makeNew) {
            $copyObj->setNew(true);
            $copyObj->setId(NULL); // this is a auto-increment column, so set to default value
        }
    }

    /**
     * Makes a copy of this object that will be inserted as a new row in table when saved.
     * It creates a new object filling in the simple attributes, but skipping any primary
     * keys that are defined for the table.
     *
     * If desired, this method can also make copies of all associated (fkey referrers)
     * objects.
     *
     * @param  boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
     * @return \Eater\Glim\Model\Server Clone of current object.
     * @throws PropelException
     */
    public function copy($deepCopy = false)
    {
        // we use get_class(), because this might be a subclass
        $clazz = get_class($this);
        $copyObj = new $clazz();
        $this->copyInto($copyObj, $deepCopy);

        return $copyObj;
    }

    /**
     * Clears the current object, sets all attributes to their default values and removes
     * outgoing references as well as back-references (from other objects to this one. Results probably in a database
     * change of those foreign objects when you call `save` there).
     */
    public function clear()
    {
        $this->id = null;
        $this->fqdn = null;
        $this->fingerprint = null;
        $this->public_key = null;
        $this->certificate = null;
        $this->location = null;
        $this->speed = null;
        $this->external_ip = null;
        $this->internal_ip = null;
        $this->netmask = null;
        $this->first_dns = null;
        $this->second_dns = null;
        $this->port = null;
        $this->protocol = null;
        $this->status = null;
        $this->alreadyInSave = false;
        $this->clearAllReferences();
        $this->applyDefaultValues();
        $this->resetModified();
        $this->setNew(true);
        $this->setDeleted(false);
    }

    /**
     * Resets all references and back-references to other model objects or collections of model objects.
     *
     * This method is used to reset all php object references (not the actual reference in the database).
     * Necessary for object serialisation.
     *
     * @param      boolean $deep Whether to also clear the references on all referrer objects.
     */
    public function clearAllReferences($deep = false)
    {
        if ($deep) {
        } // if ($deep)

    }

    /**
     * Return the string representation of this object
     *
     * @return string
     */
    public function __toString()
    {
        return (string) $this->exportTo(ServerTableMap::DEFAULT_STRING_FORMAT);
    }

    /**
     * Code to be run before persisting the object
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preSave(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after persisting the object
     * @param ConnectionInterface $con
     */
    public function postSave(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before inserting to database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preInsert(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after inserting to database
     * @param ConnectionInterface $con
     */
    public function postInsert(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before updating the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preUpdate(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after updating the object in database
     * @param ConnectionInterface $con
     */
    public function postUpdate(ConnectionInterface $con = null)
    {

    }

    /**
     * Code to be run before deleting the object in database
     * @param  ConnectionInterface $con
     * @return boolean
     */
    public function preDelete(ConnectionInterface $con = null)
    {
        return true;
    }

    /**
     * Code to be run after deleting the object in database
     * @param ConnectionInterface $con
     */
    public function postDelete(ConnectionInterface $con = null)
    {

    }


    /**
     * Derived method to catches calls to undefined methods.
     *
     * Provides magic import/export method support (fromXML()/toXML(), fromYAML()/toYAML(), etc.).
     * Allows to define default __call() behavior if you overwrite __call()
     *
     * @param string $name
     * @param mixed  $params
     *
     * @return array|string
     */
    public function __call($name, $params)
    {
        if (0 === strpos($name, 'get')) {
            $virtualColumn = substr($name, 3);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }

            $virtualColumn = lcfirst($virtualColumn);
            if ($this->hasVirtualColumn($virtualColumn)) {
                return $this->getVirtualColumn($virtualColumn);
            }
        }

        if (0 === strpos($name, 'from')) {
            $format = substr($name, 4);

            return $this->importFrom($format, reset($params));
        }

        if (0 === strpos($name, 'to')) {
            $format = substr($name, 2);
            $includeLazyLoadColumns = isset($params[0]) ? $params[0] : true;

            return $this->exportTo($format, $includeLazyLoadColumns);
        }

        throw new BadMethodCallException(sprintf('Call to undefined method: %s.', $name));
    }

}
