<?php

namespace Eater\Glim\Model\Base;

use \Exception;
use \PDO;
use Eater\Glim\Model\Server as ChildServer;
use Eater\Glim\Model\ServerQuery as ChildServerQuery;
use Eater\Glim\Model\Map\ServerTableMap;
use Propel\Runtime\Propel;
use Propel\Runtime\ActiveQuery\Criteria;
use Propel\Runtime\ActiveQuery\ModelCriteria;
use Propel\Runtime\Collection\ObjectCollection;
use Propel\Runtime\Connection\ConnectionInterface;
use Propel\Runtime\Exception\PropelException;

/**
 * Base class that represents a query for the 'Server' table.
 *
 *
 *
 * @method     ChildServerQuery orderById($order = Criteria::ASC) Order by the id column
 * @method     ChildServerQuery orderByFqdn($order = Criteria::ASC) Order by the fqdn column
 * @method     ChildServerQuery orderByFingerprint($order = Criteria::ASC) Order by the fingerprint column
 * @method     ChildServerQuery orderByPublicKey($order = Criteria::ASC) Order by the public_key column
 * @method     ChildServerQuery orderByCertificate($order = Criteria::ASC) Order by the certificate column
 * @method     ChildServerQuery orderByLocation($order = Criteria::ASC) Order by the location column
 * @method     ChildServerQuery orderBySpeed($order = Criteria::ASC) Order by the speed column
 * @method     ChildServerQuery orderByExternalIp($order = Criteria::ASC) Order by the external_ip column
 * @method     ChildServerQuery orderByInternalIp($order = Criteria::ASC) Order by the internal_ip column
 * @method     ChildServerQuery orderByNetmask($order = Criteria::ASC) Order by the netmask column
 * @method     ChildServerQuery orderByFirstDns($order = Criteria::ASC) Order by the first_dns column
 * @method     ChildServerQuery orderBySecondDns($order = Criteria::ASC) Order by the second_dns column
 * @method     ChildServerQuery orderByPort($order = Criteria::ASC) Order by the port column
 * @method     ChildServerQuery orderByProtocol($order = Criteria::ASC) Order by the protocol column
 * @method     ChildServerQuery orderByStatus($order = Criteria::ASC) Order by the status column
 *
 * @method     ChildServerQuery groupById() Group by the id column
 * @method     ChildServerQuery groupByFqdn() Group by the fqdn column
 * @method     ChildServerQuery groupByFingerprint() Group by the fingerprint column
 * @method     ChildServerQuery groupByPublicKey() Group by the public_key column
 * @method     ChildServerQuery groupByCertificate() Group by the certificate column
 * @method     ChildServerQuery groupByLocation() Group by the location column
 * @method     ChildServerQuery groupBySpeed() Group by the speed column
 * @method     ChildServerQuery groupByExternalIp() Group by the external_ip column
 * @method     ChildServerQuery groupByInternalIp() Group by the internal_ip column
 * @method     ChildServerQuery groupByNetmask() Group by the netmask column
 * @method     ChildServerQuery groupByFirstDns() Group by the first_dns column
 * @method     ChildServerQuery groupBySecondDns() Group by the second_dns column
 * @method     ChildServerQuery groupByPort() Group by the port column
 * @method     ChildServerQuery groupByProtocol() Group by the protocol column
 * @method     ChildServerQuery groupByStatus() Group by the status column
 *
 * @method     ChildServerQuery leftJoin($relation) Adds a LEFT JOIN clause to the query
 * @method     ChildServerQuery rightJoin($relation) Adds a RIGHT JOIN clause to the query
 * @method     ChildServerQuery innerJoin($relation) Adds a INNER JOIN clause to the query
 *
 * @method     ChildServer findOne(ConnectionInterface $con = null) Return the first ChildServer matching the query
 * @method     ChildServer findOneOrCreate(ConnectionInterface $con = null) Return the first ChildServer matching the query, or a new ChildServer object populated from the query conditions when no match is found
 *
 * @method     ChildServer findOneById(int $id) Return the first ChildServer filtered by the id column
 * @method     ChildServer findOneByFqdn(string $fqdn) Return the first ChildServer filtered by the fqdn column
 * @method     ChildServer findOneByFingerprint(string $fingerprint) Return the first ChildServer filtered by the fingerprint column
 * @method     ChildServer findOneByPublicKey(string $public_key) Return the first ChildServer filtered by the public_key column
 * @method     ChildServer findOneByCertificate(string $certificate) Return the first ChildServer filtered by the certificate column
 * @method     ChildServer findOneByLocation(string $location) Return the first ChildServer filtered by the location column
 * @method     ChildServer findOneBySpeed(int $speed) Return the first ChildServer filtered by the speed column
 * @method     ChildServer findOneByExternalIp(string $external_ip) Return the first ChildServer filtered by the external_ip column
 * @method     ChildServer findOneByInternalIp(string $internal_ip) Return the first ChildServer filtered by the internal_ip column
 * @method     ChildServer findOneByNetmask(int $netmask) Return the first ChildServer filtered by the netmask column
 * @method     ChildServer findOneByFirstDns(string $first_dns) Return the first ChildServer filtered by the first_dns column
 * @method     ChildServer findOneBySecondDns(string $second_dns) Return the first ChildServer filtered by the second_dns column
 * @method     ChildServer findOneByPort(int $port) Return the first ChildServer filtered by the port column
 * @method     ChildServer findOneByProtocol(int $protocol) Return the first ChildServer filtered by the protocol column
 * @method     ChildServer findOneByStatus(int $status) Return the first ChildServer filtered by the status column *

 * @method     ChildServer requirePk($key, ConnectionInterface $con = null) Return the ChildServer by primary key and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOne(ConnectionInterface $con = null) Return the first ChildServer matching the query and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildServer requireOneById(int $id) Return the first ChildServer filtered by the id column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByFqdn(string $fqdn) Return the first ChildServer filtered by the fqdn column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByFingerprint(string $fingerprint) Return the first ChildServer filtered by the fingerprint column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByPublicKey(string $public_key) Return the first ChildServer filtered by the public_key column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByCertificate(string $certificate) Return the first ChildServer filtered by the certificate column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByLocation(string $location) Return the first ChildServer filtered by the location column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneBySpeed(int $speed) Return the first ChildServer filtered by the speed column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByExternalIp(string $external_ip) Return the first ChildServer filtered by the external_ip column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByInternalIp(string $internal_ip) Return the first ChildServer filtered by the internal_ip column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByNetmask(int $netmask) Return the first ChildServer filtered by the netmask column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByFirstDns(string $first_dns) Return the first ChildServer filtered by the first_dns column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneBySecondDns(string $second_dns) Return the first ChildServer filtered by the second_dns column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByPort(int $port) Return the first ChildServer filtered by the port column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByProtocol(int $protocol) Return the first ChildServer filtered by the protocol column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 * @method     ChildServer requireOneByStatus(int $status) Return the first ChildServer filtered by the status column and throws \Propel\Runtime\Exception\EntityNotFoundException when not found
 *
 * @method     ChildServer[]|ObjectCollection find(ConnectionInterface $con = null) Return ChildServer objects based on current ModelCriteria
 * @method     ChildServer[]|ObjectCollection findById(int $id) Return ChildServer objects filtered by the id column
 * @method     ChildServer[]|ObjectCollection findByFqdn(string $fqdn) Return ChildServer objects filtered by the fqdn column
 * @method     ChildServer[]|ObjectCollection findByFingerprint(string $fingerprint) Return ChildServer objects filtered by the fingerprint column
 * @method     ChildServer[]|ObjectCollection findByPublicKey(string $public_key) Return ChildServer objects filtered by the public_key column
 * @method     ChildServer[]|ObjectCollection findByCertificate(string $certificate) Return ChildServer objects filtered by the certificate column
 * @method     ChildServer[]|ObjectCollection findByLocation(string $location) Return ChildServer objects filtered by the location column
 * @method     ChildServer[]|ObjectCollection findBySpeed(int $speed) Return ChildServer objects filtered by the speed column
 * @method     ChildServer[]|ObjectCollection findByExternalIp(string $external_ip) Return ChildServer objects filtered by the external_ip column
 * @method     ChildServer[]|ObjectCollection findByInternalIp(string $internal_ip) Return ChildServer objects filtered by the internal_ip column
 * @method     ChildServer[]|ObjectCollection findByNetmask(int $netmask) Return ChildServer objects filtered by the netmask column
 * @method     ChildServer[]|ObjectCollection findByFirstDns(string $first_dns) Return ChildServer objects filtered by the first_dns column
 * @method     ChildServer[]|ObjectCollection findBySecondDns(string $second_dns) Return ChildServer objects filtered by the second_dns column
 * @method     ChildServer[]|ObjectCollection findByPort(int $port) Return ChildServer objects filtered by the port column
 * @method     ChildServer[]|ObjectCollection findByProtocol(int $protocol) Return ChildServer objects filtered by the protocol column
 * @method     ChildServer[]|ObjectCollection findByStatus(int $status) Return ChildServer objects filtered by the status column
 * @method     ChildServer[]|\Propel\Runtime\Util\PropelModelPager paginate($page = 1, $maxPerPage = 10, ConnectionInterface $con = null) Issue a SELECT query based on the current ModelCriteria and uses a page and a maximum number of results per page to compute an offset and a limit
 *
 */
abstract class ServerQuery extends ModelCriteria
{
    protected $entityNotFoundExceptionClass = '\\Propel\\Runtime\\Exception\\EntityNotFoundException';

    /**
     * Initializes internal state of \Eater\Glim\Model\Base\ServerQuery object.
     *
     * @param     string $dbName The database name
     * @param     string $modelName The phpName of a model, e.g. 'Book'
     * @param     string $modelAlias The alias for the model in this query, e.g. 'b'
     */
    public function __construct($dbName = 'default', $modelName = '\\Eater\\Glim\\Model\\Server', $modelAlias = null)
    {
        parent::__construct($dbName, $modelName, $modelAlias);
    }

    /**
     * Returns a new ChildServerQuery object.
     *
     * @param     string $modelAlias The alias of a model in the query
     * @param     Criteria $criteria Optional Criteria to build the query from
     *
     * @return ChildServerQuery
     */
    public static function create($modelAlias = null, Criteria $criteria = null)
    {
        if ($criteria instanceof ChildServerQuery) {
            return $criteria;
        }
        $query = new ChildServerQuery();
        if (null !== $modelAlias) {
            $query->setModelAlias($modelAlias);
        }
        if ($criteria instanceof Criteria) {
            $query->mergeWith($criteria);
        }

        return $query;
    }

    /**
     * Find object by primary key.
     * Propel uses the instance pool to skip the database if the object exists.
     * Go fast if the query is untouched.
     *
     * <code>
     * $obj  = $c->findPk(12, $con);
     * </code>
     *
     * @param mixed $key Primary key to use for the query
     * @param ConnectionInterface $con an optional connection object
     *
     * @return ChildServer|array|mixed the result, formatted by the current formatter
     */
    public function findPk($key, ConnectionInterface $con = null)
    {
        if ($key === null) {
            return null;
        }
        if ((null !== ($obj = ServerTableMap::getInstanceFromPool((string) $key))) && !$this->formatter) {
            // the object is already in the instance pool
            return $obj;
        }
        if ($con === null) {
            $con = Propel::getServiceContainer()->getReadConnection(ServerTableMap::DATABASE_NAME);
        }
        $this->basePreSelect($con);
        if ($this->formatter || $this->modelAlias || $this->with || $this->select
         || $this->selectColumns || $this->asColumns || $this->selectModifiers
         || $this->map || $this->having || $this->joins) {
            return $this->findPkComplex($key, $con);
        } else {
            return $this->findPkSimple($key, $con);
        }
    }

    /**
     * Find object by primary key using raw SQL to go fast.
     * Bypass doSelect() and the object formatter by using generated code.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @throws \Propel\Runtime\Exception\PropelException
     *
     * @return ChildServer A model object, or null if the key is not found
     */
    protected function findPkSimple($key, ConnectionInterface $con)
    {
        $sql = 'SELECT id, fqdn, fingerprint, public_key, certificate, location, speed, external_ip, internal_ip, netmask, first_dns, second_dns, port, protocol, status FROM Server WHERE id = :p0';
        try {
            $stmt = $con->prepare($sql);
            $stmt->bindValue(':p0', $key, PDO::PARAM_INT);
            $stmt->execute();
        } catch (Exception $e) {
            Propel::log($e->getMessage(), Propel::LOG_ERR);
            throw new PropelException(sprintf('Unable to execute SELECT statement [%s]', $sql), 0, $e);
        }
        $obj = null;
        if ($row = $stmt->fetch(\PDO::FETCH_NUM)) {
            /** @var ChildServer $obj */
            $obj = new ChildServer();
            $obj->hydrate($row);
            ServerTableMap::addInstanceToPool($obj, (string) $key);
        }
        $stmt->closeCursor();

        return $obj;
    }

    /**
     * Find object by primary key.
     *
     * @param     mixed $key Primary key to use for the query
     * @param     ConnectionInterface $con A connection object
     *
     * @return ChildServer|array|mixed the result, formatted by the current formatter
     */
    protected function findPkComplex($key, ConnectionInterface $con)
    {
        // As the query uses a PK condition, no limit(1) is necessary.
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKey($key)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->formatOne($dataFetcher);
    }

    /**
     * Find objects by primary key
     * <code>
     * $objs = $c->findPks(array(12, 56, 832), $con);
     * </code>
     * @param     array $keys Primary keys to use for the query
     * @param     ConnectionInterface $con an optional connection object
     *
     * @return ObjectCollection|array|mixed the list of results, formatted by the current formatter
     */
    public function findPks($keys, ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getReadConnection($this->getDbName());
        }
        $this->basePreSelect($con);
        $criteria = $this->isKeepQuery() ? clone $this : $this;
        $dataFetcher = $criteria
            ->filterByPrimaryKeys($keys)
            ->doSelect($con);

        return $criteria->getFormatter()->init($criteria)->format($dataFetcher);
    }

    /**
     * Filter the query by primary key
     *
     * @param     mixed $key Primary key to use for the query
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByPrimaryKey($key)
    {

        return $this->addUsingAlias(ServerTableMap::COL_ID, $key, Criteria::EQUAL);
    }

    /**
     * Filter the query by a list of primary keys
     *
     * @param     array $keys The list of primary key to use for the query
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByPrimaryKeys($keys)
    {

        return $this->addUsingAlias(ServerTableMap::COL_ID, $keys, Criteria::IN);
    }

    /**
     * Filter the query on the id column
     *
     * Example usage:
     * <code>
     * $query->filterById(1234); // WHERE id = 1234
     * $query->filterById(array(12, 34)); // WHERE id IN (12, 34)
     * $query->filterById(array('min' => 12)); // WHERE id > 12
     * </code>
     *
     * @param     mixed $id The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterById($id = null, $comparison = null)
    {
        if (is_array($id)) {
            $useMinMax = false;
            if (isset($id['min'])) {
                $this->addUsingAlias(ServerTableMap::COL_ID, $id['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($id['max'])) {
                $this->addUsingAlias(ServerTableMap::COL_ID, $id['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_ID, $id, $comparison);
    }

    /**
     * Filter the query on the fqdn column
     *
     * Example usage:
     * <code>
     * $query->filterByFqdn('fooValue');   // WHERE fqdn = 'fooValue'
     * $query->filterByFqdn('%fooValue%'); // WHERE fqdn LIKE '%fooValue%'
     * </code>
     *
     * @param     string $fqdn The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByFqdn($fqdn = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($fqdn)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $fqdn)) {
                $fqdn = str_replace('*', '%', $fqdn);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_FQDN, $fqdn, $comparison);
    }

    /**
     * Filter the query on the fingerprint column
     *
     * Example usage:
     * <code>
     * $query->filterByFingerprint('fooValue');   // WHERE fingerprint = 'fooValue'
     * $query->filterByFingerprint('%fooValue%'); // WHERE fingerprint LIKE '%fooValue%'
     * </code>
     *
     * @param     string $fingerprint The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByFingerprint($fingerprint = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($fingerprint)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $fingerprint)) {
                $fingerprint = str_replace('*', '%', $fingerprint);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_FINGERPRINT, $fingerprint, $comparison);
    }

    /**
     * Filter the query on the public_key column
     *
     * Example usage:
     * <code>
     * $query->filterByPublicKey('fooValue');   // WHERE public_key = 'fooValue'
     * $query->filterByPublicKey('%fooValue%'); // WHERE public_key LIKE '%fooValue%'
     * </code>
     *
     * @param     string $publicKey The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByPublicKey($publicKey = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($publicKey)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $publicKey)) {
                $publicKey = str_replace('*', '%', $publicKey);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_PUBLIC_KEY, $publicKey, $comparison);
    }

    /**
     * Filter the query on the certificate column
     *
     * Example usage:
     * <code>
     * $query->filterByCertificate('fooValue');   // WHERE certificate = 'fooValue'
     * $query->filterByCertificate('%fooValue%'); // WHERE certificate LIKE '%fooValue%'
     * </code>
     *
     * @param     string $certificate The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByCertificate($certificate = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($certificate)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $certificate)) {
                $certificate = str_replace('*', '%', $certificate);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_CERTIFICATE, $certificate, $comparison);
    }

    /**
     * Filter the query on the location column
     *
     * Example usage:
     * <code>
     * $query->filterByLocation('fooValue');   // WHERE location = 'fooValue'
     * $query->filterByLocation('%fooValue%'); // WHERE location LIKE '%fooValue%'
     * </code>
     *
     * @param     string $location The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByLocation($location = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($location)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $location)) {
                $location = str_replace('*', '%', $location);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_LOCATION, $location, $comparison);
    }

    /**
     * Filter the query on the speed column
     *
     * Example usage:
     * <code>
     * $query->filterBySpeed(1234); // WHERE speed = 1234
     * $query->filterBySpeed(array(12, 34)); // WHERE speed IN (12, 34)
     * $query->filterBySpeed(array('min' => 12)); // WHERE speed > 12
     * </code>
     *
     * @param     mixed $speed The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterBySpeed($speed = null, $comparison = null)
    {
        if (is_array($speed)) {
            $useMinMax = false;
            if (isset($speed['min'])) {
                $this->addUsingAlias(ServerTableMap::COL_SPEED, $speed['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($speed['max'])) {
                $this->addUsingAlias(ServerTableMap::COL_SPEED, $speed['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_SPEED, $speed, $comparison);
    }

    /**
     * Filter the query on the external_ip column
     *
     * Example usage:
     * <code>
     * $query->filterByExternalIp('fooValue');   // WHERE external_ip = 'fooValue'
     * $query->filterByExternalIp('%fooValue%'); // WHERE external_ip LIKE '%fooValue%'
     * </code>
     *
     * @param     string $externalIp The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByExternalIp($externalIp = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($externalIp)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $externalIp)) {
                $externalIp = str_replace('*', '%', $externalIp);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_EXTERNAL_IP, $externalIp, $comparison);
    }

    /**
     * Filter the query on the internal_ip column
     *
     * Example usage:
     * <code>
     * $query->filterByInternalIp('fooValue');   // WHERE internal_ip = 'fooValue'
     * $query->filterByInternalIp('%fooValue%'); // WHERE internal_ip LIKE '%fooValue%'
     * </code>
     *
     * @param     string $internalIp The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByInternalIp($internalIp = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($internalIp)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $internalIp)) {
                $internalIp = str_replace('*', '%', $internalIp);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_INTERNAL_IP, $internalIp, $comparison);
    }

    /**
     * Filter the query on the netmask column
     *
     * Example usage:
     * <code>
     * $query->filterByNetmask(1234); // WHERE netmask = 1234
     * $query->filterByNetmask(array(12, 34)); // WHERE netmask IN (12, 34)
     * $query->filterByNetmask(array('min' => 12)); // WHERE netmask > 12
     * </code>
     *
     * @param     mixed $netmask The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByNetmask($netmask = null, $comparison = null)
    {
        if (is_array($netmask)) {
            $useMinMax = false;
            if (isset($netmask['min'])) {
                $this->addUsingAlias(ServerTableMap::COL_NETMASK, $netmask['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($netmask['max'])) {
                $this->addUsingAlias(ServerTableMap::COL_NETMASK, $netmask['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_NETMASK, $netmask, $comparison);
    }

    /**
     * Filter the query on the first_dns column
     *
     * Example usage:
     * <code>
     * $query->filterByFirstDns('fooValue');   // WHERE first_dns = 'fooValue'
     * $query->filterByFirstDns('%fooValue%'); // WHERE first_dns LIKE '%fooValue%'
     * </code>
     *
     * @param     string $firstDns The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByFirstDns($firstDns = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($firstDns)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $firstDns)) {
                $firstDns = str_replace('*', '%', $firstDns);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_FIRST_DNS, $firstDns, $comparison);
    }

    /**
     * Filter the query on the second_dns column
     *
     * Example usage:
     * <code>
     * $query->filterBySecondDns('fooValue');   // WHERE second_dns = 'fooValue'
     * $query->filterBySecondDns('%fooValue%'); // WHERE second_dns LIKE '%fooValue%'
     * </code>
     *
     * @param     string $secondDns The value to use as filter.
     *              Accepts wildcards (* and % trigger a LIKE)
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterBySecondDns($secondDns = null, $comparison = null)
    {
        if (null === $comparison) {
            if (is_array($secondDns)) {
                $comparison = Criteria::IN;
            } elseif (preg_match('/[\%\*]/', $secondDns)) {
                $secondDns = str_replace('*', '%', $secondDns);
                $comparison = Criteria::LIKE;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_SECOND_DNS, $secondDns, $comparison);
    }

    /**
     * Filter the query on the port column
     *
     * Example usage:
     * <code>
     * $query->filterByPort(1234); // WHERE port = 1234
     * $query->filterByPort(array(12, 34)); // WHERE port IN (12, 34)
     * $query->filterByPort(array('min' => 12)); // WHERE port > 12
     * </code>
     *
     * @param     mixed $port The value to use as filter.
     *              Use scalar values for equality.
     *              Use array values for in_array() equivalent.
     *              Use associative array('min' => $minValue, 'max' => $maxValue) for intervals.
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByPort($port = null, $comparison = null)
    {
        if (is_array($port)) {
            $useMinMax = false;
            if (isset($port['min'])) {
                $this->addUsingAlias(ServerTableMap::COL_PORT, $port['min'], Criteria::GREATER_EQUAL);
                $useMinMax = true;
            }
            if (isset($port['max'])) {
                $this->addUsingAlias(ServerTableMap::COL_PORT, $port['max'], Criteria::LESS_EQUAL);
                $useMinMax = true;
            }
            if ($useMinMax) {
                return $this;
            }
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_PORT, $port, $comparison);
    }

    /**
     * Filter the query on the protocol column
     *
     * @param     mixed $protocol The value to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByProtocol($protocol = null, $comparison = null)
    {
        $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_PROTOCOL);
        if (is_scalar($protocol)) {
            if (!in_array($protocol, $valueSet)) {
                throw new PropelException(sprintf('Value "%s" is not accepted in this enumerated column', $protocol));
            }
            $protocol = array_search($protocol, $valueSet);
        } elseif (is_array($protocol)) {
            $convertedValues = array();
            foreach ($protocol as $value) {
                if (!in_array($value, $valueSet)) {
                    throw new PropelException(sprintf('Value "%s" is not accepted in this enumerated column', $value));
                }
                $convertedValues []= array_search($value, $valueSet);
            }
            $protocol = $convertedValues;
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_PROTOCOL, $protocol, $comparison);
    }

    /**
     * Filter the query on the status column
     *
     * @param     mixed $status The value to use as filter
     * @param     string $comparison Operator to use for the column comparison, defaults to Criteria::EQUAL
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function filterByStatus($status = null, $comparison = null)
    {
        $valueSet = ServerTableMap::getValueSet(ServerTableMap::COL_STATUS);
        if (is_scalar($status)) {
            if (!in_array($status, $valueSet)) {
                throw new PropelException(sprintf('Value "%s" is not accepted in this enumerated column', $status));
            }
            $status = array_search($status, $valueSet);
        } elseif (is_array($status)) {
            $convertedValues = array();
            foreach ($status as $value) {
                if (!in_array($value, $valueSet)) {
                    throw new PropelException(sprintf('Value "%s" is not accepted in this enumerated column', $value));
                }
                $convertedValues []= array_search($value, $valueSet);
            }
            $status = $convertedValues;
            if (null === $comparison) {
                $comparison = Criteria::IN;
            }
        }

        return $this->addUsingAlias(ServerTableMap::COL_STATUS, $status, $comparison);
    }

    /**
     * Exclude object from result
     *
     * @param   ChildServer $server Object to remove from the list of results
     *
     * @return $this|ChildServerQuery The current query, for fluid interface
     */
    public function prune($server = null)
    {
        if ($server) {
            $this->addUsingAlias(ServerTableMap::COL_ID, $server->getId(), Criteria::NOT_EQUAL);
        }

        return $this;
    }

    /**
     * Deletes all rows from the Server table.
     *
     * @param ConnectionInterface $con the connection to use
     * @return int The number of affected rows (if supported by underlying database driver).
     */
    public function doDeleteAll(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(ServerTableMap::DATABASE_NAME);
        }

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con) {
            $affectedRows = 0; // initialize var to track total num of affected rows
            $affectedRows += parent::doDeleteAll($con);
            // Because this db requires some delete cascade/set null emulation, we have to
            // clear the cached instance *after* the emulation has happened (since
            // instances get re-added by the select statement contained therein).
            ServerTableMap::clearInstancePool();
            ServerTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

    /**
     * Performs a DELETE on the database based on the current ModelCriteria
     *
     * @param ConnectionInterface $con the connection to use
     * @return int             The number of affected rows (if supported by underlying database driver).  This includes CASCADE-related rows
     *                         if supported by native driver or if emulated using Propel.
     * @throws PropelException Any exceptions caught during processing will be
     *                         rethrown wrapped into a PropelException.
     */
    public function delete(ConnectionInterface $con = null)
    {
        if (null === $con) {
            $con = Propel::getServiceContainer()->getWriteConnection(ServerTableMap::DATABASE_NAME);
        }

        $criteria = $this;

        // Set the correct dbName
        $criteria->setDbName(ServerTableMap::DATABASE_NAME);

        // use transaction because $criteria could contain info
        // for more than one table or we could emulating ON DELETE CASCADE, etc.
        return $con->transaction(function () use ($con, $criteria) {
            $affectedRows = 0; // initialize var to track total num of affected rows

            ServerTableMap::removeInstanceFromPool($criteria);

            $affectedRows += ModelCriteria::delete($con);
            ServerTableMap::clearRelatedInstancePool();

            return $affectedRows;
        });
    }

} // ServerQuery
